
//=======================================================
//  This code is generated by Terasic System Builder
//=======================================================

module DE10_LITE_WIFI_TIME_RTL(

	//////////// CLOCK //////////
	input 		          		ADC_CLK_10,
	input 		          		MAX10_CLK1_50,
	input 		          		MAX10_CLK2_50,

	//////////// SEG7 //////////
	output		     [7:0]		HEX0,
	output		     [7:0]		HEX1,
	output		     [7:0]		HEX2,
	output		     [7:0]		HEX3,
	output		     [7:0]		HEX4,
	output		     [7:0]		HEX5,

	//////////// KEY //////////
	input 		     [1:0]		KEY,

	//////////// LED //////////
	output		     [9:0]		LEDR,

	//////////// SW //////////
	input 		     [9:0]		SW,

	//////////// GPIO, GPIO connect to RFS - RF and Sensor //////////
	inout 		          		BT_KEY,
	input 		          		BT_UART_RX,
	output		          		BT_UART_TX,
	input 		          		LSENSOR_INT,
	inout 		          		LSENSOR_SCL,
	inout 		          		LSENSOR_SDA,
	output		          		MPU_AD0_SDO,
	output		          		MPU_CS_n,
	output		          		MPU_FSYNC,
	input 		          		MPU_INT,
	inout 		          		MPU_SCL_SCLK,
	inout 		          		MPU_SDA_SDI,
	input 		          		RH_TEMP_DRDY_n,
	inout 		          		RH_TEMP_I2C_SCL,
	inout 		          		RH_TEMP_I2C_SDA,
	inout 		     [7:0]		TMD_D,
	input 		          		UART2USB_CTS,
	output		          		UART2USB_RTS,
	input 		          		UART2USB_RX,
	output		          		UART2USB_TX,
	output		          		WIFI_EN,
	output		          		WIFI_RST_n,
	input 		          		WIFI_UART0_CTS,
	output		          		WIFI_UART0_RTS,
	input 		          		WIFI_UART0_RX,
	output		          		WIFI_UART0_TX,
	input 		          		WIFI_UART1_RX
);


//=======================================================
//  REG/WIRE declarations
//=======================================================
wire		      DLY_RST;
wire [23:0]	   mSEG7_DIG;
wire           UART_RXD_TXD ; 
wire           ADDRESS  ;
wire           CS       ;
wire [3:0]     BYTE_ENABLE     ;
wire           READ     ;
wire           WRITE    ;
wire           IRQ      ;
wire [31:0]    WRITEDATA;
wire [31:0]    READDATA ;
wire           READY ;
wire           UART_RX_1 ; 
wire [7:0]     SS;
wire [7:0]     MM;
wire [7:0]     HH;
wire [7:0]     MESSAGE;
wire [159: 0 ] NAME; 
wire [159: 0 ] PASSWORD; 
wire [159: 0 ] oNAME; 
wire [159: 0 ] oPASSWORD; 
wire [7: 0 ]   NAME_LN     ;
wire [7: 0 ]   PASSWORD_LN ;

//=======================================================
//  Structural coding
//=======================================================
// initial // 

assign WIFI_UART0_RTS  = 0;
assign WIFI_EN         = 1 ; 
assign WIFI_RST_n      = KEY [0]   &  DLY_RST ;
	

//---- RESET DELAY  ---	
Reset_Delay	 r0	(	
      .iRESET_N ( KEY [0])  , 
		.iCLK     ( MAX10_CLK2_50 ),
		.oRESET   ( DLY_RST  )		
	);
		

//----  FROM ESP8266 RX  ---	
assign UART_RX_1  = READY? WIFI_UART0_RX :1  ; 

//--- NAME & PASSWORD    
assign NAME      = ""; 
assign PASSWORD  = "";  


//--- NAME & PASSWORD String Check  
 NAME_PASSWD  cf( 
   .CLK        ( MAX10_CLK2_50  ) ,
   .RESET_N    ( KEY [0]  ), 
   .NAME       ( NAME     ), 
   .PASSWORD   ( PASSWORD ),
   .NAME_LN    ( NAME_LN  ),
   .PASSWORD_LN( PASSWORD_LN ),
   .oNAME      ( oNAME     ),
   .oPASSWORD  ( oPASSWORD )
) ; 

//-- WIFI COMMAND SEQUENCE CONTROLLER -- 
UART_ST   st    (
	.NAME        ( oNAME) , 
   .PASSWORD    ( oPASSWORD),
   .NAME_LN     ( NAME_LN ), 
   .PASSWORD_LN ( PASSWORD_LN ),	
   .CLK         ( MAX10_CLK2_50 ) ,
   .RESET_N     ( DLY_RST  ) ,
   .RX         ( UART_RX_1  ), 
   //--UART IP BUS 
   .ADDRESS     ( ADDRESS  ) ,
   .CS          ( CS       ) ,
   .BYTE_ENABLE ( BYTE_ENABLE ),
   .READ        ( READ     ),
   .WRITE       ( WRITE    ),
   .WRITEDATA   ( WRITEDATA ),
   .READDATA    ( READDATA ),
	.READY       ( READY ) ,
	.MESSAGE     ( MESSAGE ),

	//----TO 7-SEG 
   .SS          ( SS ),
   .MM          ( MM ),  
   .HH          ( HH )
);

//--- ALTERA UART IP  --- 
UART_TX  ut  (
	.clk       ( MAX10_CLK2_50      ) ,
	.reset     ( ~READY      ),	
	.address   ( ADDRESS     ),
	.chipselect( CS          ),
	.byteenable( BYTE_ENABLE ),
	.read      ( READ        ),
	.write     ( WRITE       ),
	.writedata ( WRITEDATA   ),
	.irq       ( IRQ         ),
	.readdata  ( READDATA    ),		 
	.UART_TXD  ( WIFI_UART0_TX     )
);

//--- DISPLAY  HH:MM:SS
assign	mSEG7_DIG	= {  HH , MM,  SS };

//----7 segment LUT ---
SEG7_LUT_6 			u0	(	.oSEG0(HEX0),
							   .oSEG1(HEX1),
							   .oSEG2(HEX2),
							   .oSEG3(HEX3),
								.oSEG4(HEX4),
								.oSEG5(HEX5),
							   .iDIG ( mSEG7_DIG ));	
								
//---- LED DISPLAY  ---
assign  LEDR[9:0]    = { KEY[1:0] , READY , WIFI_UART0_RX, WIFI_UART0_TX,  MESSAGE[3:0] } ;

endmodule




