module BAUD_GEN(
     input                tr , 
     output               RETT ,
     input                clk_i,
     input                rst_i,
     output     reg       baud_tick,
     input      [31:0]    baud_freq_i,
     input      [31:0]    baud_limit_i,
     output reg [31:0]    count
 );

 
reg rtr ; 
always @(posedge clk_i ) rtr <= tr ;

assign RETT  = ( rtr  && !tr )?0:1 ;

always @(posedge clk_i or negedge RETT)
begin
    if (!RETT)
        count <= baud_limit_i/2 ;
    else if (    count > baud_limit_i )
        count <= count - baud_limit_i;
    else
        count <= count + baud_freq_i;
end
 
always @(posedge clk_i or negedge RETT )
begin
    if (!RETT)        baud_tick <= 1'b0;

    else if (count   >   baud_limit_i  )
        baud_tick <= 1'b1;
    else
        baud_tick <= 1'b0;
end
 
endmodule
