
//=======================================================
//  This code is generated by Terasic System Builder
//=======================================================

module TR4_230_RFS_SENSOR(

	//////////// CLOCK //////////
	input 		          		OSC_50_BANK1,
	input 		          		OSC_50_BANK3,
	input 		          		OSC_50_BANK4,
	input 		          		OSC_50_BANK7,
	input 		          		OSC_50_BANK8,

	//////////// Loop //////////
	input 		          		LOOP_CLKIN0,
	input 		          		LOOP_CLKIN1,
	output		          		LOOP_CLKOUT0,
	output		          		LOOP_CLKOUT1,

	//////////// LED x 4 //////////
	output		     [3:0]		LED,

	//////////// BUTTON x 4 //////////
	input 		     [3:0]		BUTTON,

	//////////// SWITCH x 4 //////////
	input 		     [3:0]		SW,

	//////////// Temperature //////////
	input 		          		TEMP_INT_n,
	input 		          		TEMP_OVERT_n,
	output		          		TEMP_SMCLK,
	inout 		          		TEMP_SMDAT,

	//////////// Fan //////////
	output		          		FAN_CTRL,

	//////////// Flash and SRAM Address/Data/OE/WM Share Bus //////////
	output		    [25:1]		FSM_A,
	inout 		    [31:0]		FSM_D,
	output		          		FSM_OE_n,
	output		          		FSM_WE_n,

	//////////// Flash Control //////////
	output		          		FLASH_ADV_n,
	output		          		FLASH_CE_n,
	output		          		FLASH_CLK,
	input 		          		FLASH_RDY_BSY_n,
	output		          		FLASH_RESET_n,
	output		          		FLASH_WP_n,

	//////////// SSRAM Control //////////
	output		          		SSRAM_ADSC_n,
	output		          		SSRAM_ADSP_n,
	output		          		SSRAM_ADV_n,
	output		     [3:0]		SSRAM_BE_n,
	output		          		SSRAM_CE1_n,
	output		          		SSRAM_CLK,

	//////////// GPIO_0, GPIO_0 connect to RFS - RF and Sensor //////////
	inout 		          		BT_KEY,
	input 		          		BT_UART_RX,
	output		          		BT_UART_TX,
	input 		          		LSENSOR_INT,
	inout 		          		LSENSOR_SCL,
	inout 		          		LSENSOR_SDA,
	output		          		MPU_AD0_SDO,
	output		          		MPU_CS_n,
	output		          		MPU_FSYNC,
	input 		          		MPU_INT,
	inout 		          		MPU_SCL_SCLK,
	inout 		          		MPU_SDA_SDI,
	input 		          		RH_TEMP_DRDY_n,
	inout 		          		RH_TEMP_I2C_SCL,
	inout 		          		RH_TEMP_I2C_SDA,
	inout 		     [7:0]		TMD_D,
	input 		          		UART2USB_CTS,
	output		          		UART2USB_RTS,
	input 		          		UART2USB_RX,
	output		          		UART2USB_TX,
	output		          		WIFI_EN,
	output		          		WIFI_RST_n,
	input 		          		WIFI_UART0_CTS,
	output		          		WIFI_UART0_RTS,
	input 		          		WIFI_UART0_RX,
	output		          		WIFI_UART0_TX,
	input 		          		WIFI_UART1_RX
);



//=======================================================
//  REG/WIRE declarations
//=======================================================




//=======================================================
//  Structural coding
//=======================================================
assign MPU_CS_n = 1'b1;
assign MPU_FSYNC = 1'b0;
assign MPU_AD0_SDO = 1'b0;

assign FAN_CTRL = 1'b1;


nios_qsys u0 (
		.clk_clk                                    (OSC_50_BANK1),                                    //                                 clk.clk
		.reset_reset_n                              (1'b1),                              //                               reset.reset_n

		.mpu_i2c_opencores_export_scl_pad_io        (MPU_SCL_SCLK),                 //                     mpu_i2c_export.scl_pad_io
		.mpu_i2c_opencores_export_sda_pad_io        (MPU_SDA_SDI),                 //                                   .sda_pad_io
		.mpu_int_external_connection_export         (MPU_INT),         //         mpu_int_external_connection.export

		.light_i2c_opencores_export_scl_pad_io      (LSENSOR_SCL),               //                   light_i2c_export.scl_pad_io
		.light_i2c_opencores_export_sda_pad_io      (LSENSOR_SDA),               //                                   .sda_pad_io
		.light_int_external_connection_export       (LSENSOR_INT),       //       light_int_external_connection.export

		.rh_temp_i2c_opencores_export_scl_pad_io    (RH_TEMP_I2C_SCL),             //                 rh_temp_i2c_export.scl_pad_io
		.rh_temp_i2c_opencores_export_sda_pad_io    (RH_TEMP_I2C_SDA),              //                                   .sda_pad_io
		.rh_temp_drdy_n_external_connection_export  (RH_TEMP_DRDY_n)   //  rh_temp_drdy_n_external_connection.export

						
	);


endmodule
